registerGameMode("Cops and Robbers","CR",1,1,1);
setGameModeHelp("Cops and Robbers","Add-Ons/Gamemode_CopsAndRobbers/rules_cr.txt");
addGameModeRule("Cops and Robbers","Money Stolen","int 1 10000",50);
addGameModeRule("Cops and Robbers","Money Total","int 1 10000",200);
addGameModeRule("Cops and Robbers","Cop Deaths to Free","int 0 100",3);
addGameModeRule("Cops and Robbers","Health % Left to Jail","int 10 100",50);
addGameModeRule("Cops and Robbers","Robbers Can Suicide","bool",0);
addGameModeRule("Cops and Robbers","Hide Names At Distance","int 1 600",16);
addGameModeRule("Cops and Robbers","Time Limit (Cops Win)","int 0 30",0);

function GameMode_CR_onModeUpdateRule1(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(%modeStart)
      return;
   
   %mini.messageAll('',"\c5The " @ teamName(%mini,1) @ "\c5 need \c3$" @ %mini.tdmModeRule[1] @ "\c5 to win. (\c3$" @ %mini.CRMoneyStolen @ "\c5 so far.)");
   
   if(%mini.CRMoneyStolen >= %mini.tdmModeRule[1])
      %mini.roundEnd(1,1);
   
   return 0;
}

function GameMode_CR_onModeUpdateRule3(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(%modeStart)
      return;
   
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %cl = %mini.member[%i];
      if(!isObject(%cl.player))
         continue;
      
      //Reset shape names to new value - this calls GameMode_CR_getShapeNameColor and _getShapeNameDistance
      %cl.player.setShapeNameColor("1 1 1 1");
      %cl.player.setShapeNameDistance(600);
   }
   
   return 0;
}

function GameMode_CR_onModeUpdateRule5(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(%modeStart)
      return;
   
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %cl = %mini.member[%i];
      if(!isObject(%cl.player))
         continue;
      
      //Reset shape names to new value - this calls GameMode_CR_getShapeNameColor and _getShapeNameDistance
      %cl.player.setShapeNameColor("1 1 1 1"); 
      %cl.player.setShapeNameDistance(600);
   }
   
   return 0;
}

function GameMode_CR_onModeUpdateRule6(%mini,%rulevalue,%oldvalue,%modestart)
{
   if(!%modestart)
      return 1;
}

function GameMode_CR_GetSpecialTeams(%client)
{
 //Torque networking prevents me from sending everything at once, so I do it all in parts

 //Clear teams list first
 commandtoclient(%client,'tdmSpecialClearTeams');

 //Cops team is first
 //'Blue' team, no-jets player, given a Gun and police bat
 commandtoclient(%client,'tdmSpecialSendTeam',0,"Cops" TAB
							getClosestPaintColor("0 0 1 1") TAB
							1 TAB
							PlayerNoJet.getID() TAB
							gunItem.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							crPoliceBatItem.getID() TAB
							PlayerNoJet.getID() TAB
							gunItem.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							crPoliceBatItem.getID());

 //Uniform data is sent in three 'chunks' - first ten fields, second ten, then seven

  //chest		chestCol
  //rArm		rArmCol
  //lArm		lArmCol
  //rHand		rHandCol
  //lHand		lHandCol
  //---------------------------------
  //pants		pantsCol
  //rLeg		rLegCol
  //lLeg		lLegCol
  //hat			hatCol
  //accent		accentCol
  //---------------------------------
  //pack		packCol
  //secondPack		secondPackCol
  //headCol
  //decalName		faceName

 //Police wear a generic-looking suit with the 'Police' decal
 commandtoclient(%client,'tdmSpecialStoreUniform',0,0,"0" TAB "1 1 1 1" TAB
							"0" TAB "0 0.14 0.33 1" TAB
							"0" TAB "0 0.14 0.33 1" TAB
							"0" TAB "1 0.88 0.61 1" TAB
							"0" TAB "1 0.88 0.61 1");
 commandtoclient(%client,'tdmSpecialStoreUniform',0,1,"0" TAB "0 0.14 0.33 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"6" TAB "0 0.14 0.33 1" TAB
							"0" TAB "0 0 0 1");
 commandtoclient(%client,'tdmSpecialStoreUniform',0,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"1 0.88 0.61 1" TAB
							"Mod-Police" TAB "smileyCreepy");

 //Leader uniform is the same.
 commandtoclient(%client,'tdmSpecialStoreLUniform',0,0,"0" TAB "1 1 1 1" TAB
							"0" TAB "0 0.14 0.33 1" TAB
							"0" TAB "0 0.14 0.33 1" TAB
							"0" TAB "1 0.88 0.61 1" TAB
							"0" TAB "1 0.88 0.61 1");
 commandtoclient(%client,'tdmSpecialStoreLUniform',0,1,"0" TAB "0 0.14 0.33 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"6" TAB "0 0.14 0.33 1" TAB
							"0" TAB "0 0 0 1");
 commandtoclient(%client,'tdmSpecialStoreLUniform',0,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"1 0.88 0.61 1" TAB
							"Mod-Police" TAB "smileyCreepy");

 //Robbers team is second
 //'Grey' team, quake-like player, no tools
 commandtoclient(%client,'tdmSpecialSendTeam',1,"Robbers" TAB
							getClosestPaintColor("0.5 0.5 0.5 1") TAB
							1 TAB
							PlayerQuakeArmor.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							PlayerQuakeArmor.getID() TAB
							0 TAB
							0 TAB
							0 TAB
							0 TAB
							0);

 //Robbers wear a grey uniform.
 commandtoclient(%client,'tdmSpecialStoreUniform',1,0,"0" TAB "0.5 0.5 0.5 1" TAB
							"0" TAB "0.2 0.2 0.2 1" TAB
							"0" TAB "0.2 0.2 0.2 1" TAB
							"0" TAB "1 0.88 0.61 1" TAB
							"0" TAB "1 0.88 0.61 1");
 commandtoclient(%client,'tdmSpecialStoreUniform',1,1,"0" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"7" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0 0 0 1");
 commandtoclient(%client,'tdmSpecialStoreUniform',1,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"1 0.88 0.61 1" TAB
							"Mod-Prisoner" TAB "smileyEvil2");

 //Jailed robbers have the 'leader' uniform, which is an orange prison suit.
 commandtoclient(%client,'tdmSpecialStoreLUniform',1,0,"0" TAB "0.9 0.34 0.08 1" TAB
							"0" TAB "0.9 0.34 0.08 1" TAB
							"0" TAB "0.9 0.34 0.08 1" TAB
							"0" TAB "1 0.88 0.61 1" TAB
							"0" TAB "1 0.88 0.61 1");
 commandtoclient(%client,'tdmSpecialStoreLUniform',1,1,"0" TAB "0.9 0.34 0.08 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0.08 0.08 0.08 1" TAB
							"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1");
 commandtoclient(%client,'tdmSpecialStoreLUniform',1,2,"0" TAB "0 0 0 1" TAB
							"0" TAB "0 0 0 1" TAB
							"1 0.88 0.61 1" TAB
							"Mod-Prisoner" TAB "smileyEvil2");
}

function GameMode_CR_onModeStart(%mini,%client)
{
 %mini.CRCopDeaths = 0;
 %mini.CRMoneyStolen = 0;
 
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %mini.member[%i].isCRJailed = 0;
  %mini.member[%i].CRJailTime = "";
 }
}

function GameMode_CR_onModeEnd(%mini)
{
 %mini.CRCopDeaths = 0;
 %mini.CRMoneyStolen = 0;
 
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %mini.member[%i].isCRJailed = 0;
  %mini.member[%i].CRJailTime = "";
  %mini.member[%i].bottomPrint("",0.01); //clear robbers spectating
  %mini.member[%i].tdmSpectating = 0;
 }
}

function GameMode_CR_onMiniReset(%mini,%client)
{
 %mini.CRCopDeaths = 0;
 %mini.CRMoneyStolen = 0;
 
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %mini.member[%i].isCRJailed = 0;
  %mini.member[%i].CRJailTime = "";
  %mini.member[%i].bottomPrint("",0.01); //clear robbers spectating
  %mini.member[%i].tdmSpectating = 0;
 }

 if(%mini.tdmModeRule[6] != 0)
 {
    %mini.messageAll('',"\c5The " @ teamName(%mini,1) @ "\c5 have \c3" @ %mini.tdmModeRule[6] @ "\c5 minute" @ (%mini.tdmModeRule[6] == 1 ? "" : "s") @ " to steal \c3$" @ %mini.tdmModeRule[1] @ "\c5 this round.");
    %mini.setTimeLimit(%mini.tdmModeRule[6]);
 }
}

function GameMode_CR_onTimeLimit(%mini)
{
   %mini.roundEnd(0,1);
}

function GameMode_CR_onAddMember(%mini,%client)
{
 %client.isCRJailed = 0;
 %client.CRJailTime = "";
}

function GameMode_CR_onRemoveMember(%mini,%client)
{
 %client.isCRJailed = 0;
 %client.CRJailTime = "";

 %win = 1;
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %cl = %mini.member[%i];
  if(%cl == %client)
   continue;
  if(%cl.tdmTeam == 1)
  {
   %robberExists = 1;
   if(!%cl.isCRJailed)
   {
    %win = 0;
    break;
   }
  }
 }

 if(%robberExists && %win)
  %mini.roundEnd(0,1);
}

function GameMode_CR_onClientChangeTeam(%mini,%client,%lastTeam,%newTeam)
{
 %client.isCRJailed = 0;
 %client.CRJailTime = "";
 
 if(%newTeam != 1)
 {
  %win = 1;
  for(%i=0;%i<%mini.numMembers;%i++)
  {
   %cl = %mini.member[%i];
   if(%cl == %client)
    continue;
   if(%cl.tdmTeam == 1)
   {
    %robberExists = 1;
    if(!%cl.isCRJailed)
    {
     %win = 0;
     break;
    }
   }
  }
  
  if(%robberExists && %win)
   %mini.roundEnd(0,1);
 }
}

function GameMode_CR_onClientDeath(%mini,%client,%sourceObject,%sourceClient,%damageType,%damageArea)
{
 if(%client.tdmTeam == 1 && isObject(%client.player) && %client.player.crMoney > 0)
 {
  %player = %client.player;
  %fvec = %player.getForwardVector();
  %fX = getWord(%fvec,0);
  %fY = getWord(%fvec,1);
  
  %evec = %player.getEyeVector();
  %eX = getWord(%evec,0);
  %eY = getWord(%evec,1);
  %eZ = getWord(%evec,2);
  
  %eXY = mSqrt(%eX*%eX+%eY*%eY);
  
  %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
  
  %rot = rotFromTransform(%player.getTransform());
  %rot = getWords(%rot,0,2) SPC getWord(%rot,3)*180/$pi;
  
  %item = new Item()
  {
   dataBlock = crMoneyItem;
   position = vectorAdd(%player.getHackPosition(),vectorScale(%aimVec,0));
   rotation = %rot;
   spawnBrick = %brick;
   canPickup = 1;
   static = 0;
  };MissionCleanup.add(%item);
  
  %item.moneyamt = %player.crMoney;
  %item.spawnMinigame = %mini;
  %item.setShapeNameColor("1 1 1 1");
  %item.setShapeName("$" @ %item.moneyamt);
  %item.setShapeNameDistance(16);
  %item.applyImpulse(%item.position,vectorscale(%aimVec,10));
  %item.schedule(8000,deletepoof);
 }
 else if(%client.tdmTeam == 0 && %sourceClient.tdmTeam == 1)
 {
 
 %found = -1;
 %time = $Sim::Time;
 
 for(%i=0;%i<%mini.numMembers;%i++)
 {
  %cl = %mini.member[%i];
  if(%cl.tdmTeam == 1 && %cl.isCRJailed && %cl.CRJailTime < %time)
  {
   %found = %cl;
   %time = %cl.CRJailTime;
  }
 }
 
 if(!isObject(%found))
  return;
 
 %mini.CRCopDeaths++;
 if(%mini.CRCopDeaths >= %mini.tdmModeRule[2] && %mini.tdmModeRule[2] != 0)
 {
  %mini.CRCopDeaths = 0;
  %mini.messageAll('',clientTeamName(%sourceClient) @ " \c5freed " @ clientTeamName(%found) @ "\c5 from jail!");

  %found.isCRJailed = 0;
  %found.CRJailTime = "";
  %found.instantRespawn();
 }
 }
}

function GameMode_CR_onClientSpawn(%mini,%client)
{
   if(%mini.tdmModeRule[5] == -1 || (%client.tdmTeam == 1 && %mini.tdmModeRule[3] == 100 && !%client.isCRJailed))
      %client.player.setShapeNameDistance(600);
   else
      %client.player.setShapeNameDistance(%mini.tdmModeRule[5]);
   
   if(%client.tdmTeam != 1)
      return;
   
   if(%mini.tdmModeRule[3] == 100)
      %client.player.setShapeNameColor("1 0 0 1");
   
   if(!%client.isCRJailed) //in Robbers team and Jailed
      return;
   
   for(%i=0;%i<%client.player.getDatablock().maxTools;%i++)
   {
      %client.player.tool[%i] = 0;
      messageClient(%client,'MsgItemPickup',"",%i,0,1);
   }
}

function GameMode_CR_pickSpawnPoint(%mini,%client)
{
 if(%client.tdmTeam != 1 || !%client.isCRJailed) //in Robbers team and Jailed
  return "";
 
 %numList = -1;
 %this = %mini;

 if(%this.useAllPlayersBricks)
 {
  for(%i=0;%i<%this.numMembers;%i++)
  {
   %group = %this.member[%i].brickGroup;
   if(!isObject(%group))
    continue;
   for(%j=0;%j<%group.tdmBrickCount;%j++)
   {
    %o = %group.tdmBrick[%j];
    if(%o.getDatablock().getID() == brickCRJailSpawnData.getID())
    {
     %list[%numList++] = %o;
    }
   }
  }
 }
 else
 {
  %group = %this.owner.brickGroup;
  for(%j=0;%j<%group.tdmBrickCount;%j++)
  {
   %o = %group.tdmBrick[%j];
   if(%o.getDatablock().getID() == brickCRJailSpawnData.getID())
   {
    %list[%numList++] = %o;
   }
  }
 }

 if(%numList == -1)
  return "";
 else
  return %list[getRandom(0,%numList)].getSpawnTransform();
}

function GameMode_CR_applyTeamUniform(%mini,%client)
{
 if(%client.tdmTeam == 1)
 {  
  if(%client.isCRJailed)
   return 1;
  else
   return "";
 }

 return "";
}

function GameMode_CR_getShapeNameColor(%mini,%client,%player)
{
 if(%client.tdmTeam == 1)
 {
  if(%client.isCRJailed)
     return "";
  
  %amt = %client.player.getDamagePercent();
  if(%amt*100 >= 100-%mini.tdmModeRule[3])
     return "1 0 0 1";
 }
 return "";
}

function GameMode_CR_getShapeNameDistance(%mini,%client,%player)
{
 if(!%mini.tdmHideNames)
  return "";
 if(%client.tdmTeam == 1)
 {
  if(%client.isCRJailed)
     return 600;
  
  %amt = %client.player.getDamagePercent();
  if(%amt*100 >= 100-%mini.tdmModeRule[3])
     return 600;
 }
 return %mini.tdmModeRule[5];
}

function GameMode_CR_getForceRespawn(%mini,%client)
{
   return (%client.tdmTeam == 1);
}

function GameMode_CR_canClientSpectate(%mini,%client)
{
   return (%client.tdmTeam == 1  && %client.isCRJailed);
}

function GameMode_CR_miniGameCanDamage(%mini,%obj1,%obj2,%client1,%client2)
{
 if(%obj1.getType() & $TypeMasks::VehicleObjectType || %obj2.getType() & $TypeMasks::VehicleObjectType)
  return "";
 
 if(%client1.tdmTeam == 1 && %client1.isCRJailed)
  return 0;

 if(%client2.tdmTeam == 1 && %client2.isCRJailed)
  return 0;

 return "";
}

package CRpackage
{
 function servercmdsuicide(%client)
 {
  if(!isObject(%client.minigame) || %client.minigame.gameMode != gameModeTitleToID("Cops and Robbers") || %client.tdmTeam != 1)
   return Parent::servercmdsuicide(%client);

  if(%client.isCRJailed || !%client.minigame.tdmModeRule[4])
   return;
  
  Parent::servercmdsuicide(%client);
 }
 function Armor::onDamage(%this, %obj, %amt)
 {
    Parent::onDamage(%this, %obj, %amt);
    
    %client = %obj.client;
    
    if(!isObject(%client) || !isObject(%client.minigame) || %client.minigame.gameMode != gameModeTitleToID("Cops and Robbers") || %client.tdmTeam != 1)
       return;
    
    //Reset shape name color - this calls GameMode_CR_getShapeNameColor
    %obj.setShapeNameColor("1 1 1 1");
    
    %amt = %obj.getDamagePercent();
    if(%amt*100 >= 100-%client.minigame.tdmModeRule[3])
       %obj.setShapeNameDistance(600);
 }
 function Armor::pickup(%this,%obj)
 {
  %client = %this.client;

  if(!isObject(%client) || !isObject(%client.minigame) || %client.minigame.gameMode != gameModeTitleToID("Cops and Robbers") || %client.tdmTeam != 1 || !%client.isCRJailed)
   return Parent::pickup(%this,%obj);

  %client.centerPrint("<color:FF0000>You can't use tools while in <color:FFFF00>Jail<color:FF0000>.",2);
 }
 function servercmdusetool(%client,%slot)
 {
  if(isObject(%client.minigame) && %client.minigame.gameMode == gameModeTitleToID("Cops and Robbers") && %client.tdmTeam == 1 && %client.isCRJailed)
  {
   %client.centerPrint("<color:FF0000>You can't use tools while in <color:FFFF00>Jail<color:FF0000>.",2);
   return;
  }
  Parent::servercmdusetool(%client,%slot);
 }
};activatePackage(CRPackage);

registerOutputEvent("Player","crStealMoney","int 0 10000 0",1);
function Player::crStealMoney(%this,%money,%client)
{
   if(!isObject(%client) || !isObject(%client.player) || %client.player.client != %client || %client.tdmTeam != 1 || %client.isCRJailed || %this.crMoney > 0)
      return;
   
   %mini = %client.minigame;
   
   if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Cops and Robbers"))
      return;
   
   %amt = (%money == 0 ? %client.minigame.tdmModeRule[0] : %money);
   
   %mini.messageAll('',clientTeamName(%client) @ " \c5stole \c3$" @ %amt @ "\c5 from the \c3Bank\c5!");
   %this.crMoney = %amt;
   
}

registerOutputEvent("Player","crReturnMoney","",1);
function Player::crReturnMoney(%this,%client)
{
 if(!isObject(%client) || !isObject(%client.player) || %client.player.client != %client || %client.tdmTeam != 1 || %client.isCRJailed || %this.crMoney <= 0)
    return;
 
 %mini = %client.minigame;
 
 if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Cops and Robbers"))
    return;
 
 %client.minigame.CRMoneyStolen += %this.crMoney;
 %client.minigame.CRMoneyStolen = mClampF(%client.minigame.CRMoneyStolen,0,%client.minigame.tdmModeRule[1]);
 
 %client.minigame.messageAll('',clientTeamName(%client) @ "\c5 got back to base with \c3$" @ %this.crMoney @ "\c5! (\c3$" @ %client.minigame.CRMoneyStolen @ "\c5/\c3$" @ %client.minigame.tdmModeRule[1] @ "\c5)");
 
 %this.crMoney = 0;

 if(%client.minigame.CRMoneyStolen >= %client.minigame.tdmModeRule[1])
  %client.minigame.roundEnd(1,1);
}

registerOutputEvent("Player","crJailPlayer","",0);
function Player::crJailPlayer(%this)
{
   %client = %this.client;
   if(!isObject(%client) || !isObject(%client.player) || %client.player.client != %client || %client.tdmTeam != 1 || %client.isCRJailed)
      return;
   
   %mini = %client.minigame;
   
   if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Cops and Robbers"))
      return;
   
   %client.isCRJailed = 1;
   %client.CRJailTime = $Sim::Time;
   %mini.crCopDeaths = 0;
   
   %win = 1;
   for(%i=0;%i<%mini.numMembers;%i++)
   {
      %cl = %mini.member[%i];
      if(%cl.tdmTeam == 1 && !%cl.isCRJailed)
      {
         %win = 0;
         break;
      }
   }
   
   %client.instantRespawn();
   
   if(%win)
      %mini.roundEnd(0,1);
   else
      %client.bottomPrint("\c3Jump\c6 to toggle \c3Spectator Mode\c7.",10);
}

registerOutputEvent("Player","crFreePlayer","",0);
function Player::crFreePlayer(%this)
{
   %client = %this.client;
   if(!isObject(%client) || !isObject(%client.player) || %client.player.client != %client || %client.tdmTeam != 1 || %client.isCRJailed)
      return;
   
   %mini = %client.minigame;
   
   if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Cops and Robbers"))
      return;
   
   %client.isCRJailed = 0;
   %client.CRJailTime = "";
   %mini.crCopDeaths = 0;
   %mini.messageAll('',clientTeamName(%client) @ " \c5escaped from jail!");
   
   %client.instantRespawn();
}

registerOutputEvent("Minigame","crFreePlayer","",1);
function MinigameSO::crFreePlayer(%this,%client)
{
   if(%this.roundWon || %this.gamemode != gameModeTitleToID("Cops and Robbers"))
      return;
   
   %found = -1;
   %time = $Sim::Time;
   
   for(%i=0;%i<%this.numMembers;%i++)
   {
      %cl = %this.member[%i];
      if(%cl.tdmTeam == 1 && %cl.isCRJailed && %cl.CRJailTime < %time)
      {
         %found = %cl;
         %time = %cl.CRJailTime;
      }
   }
   
   if(!isObject(%found))
      return;
   
   %found.isCRJailed = 0;
   %found.CRJailTime = "";
   %this.crCopDeaths = 0;
   %this.messageAll('',clientTeamName(%client) @ " \c5freed " @ clientTeamName(%found) @ "\c5 from jail!");
   
   %found.instantRespawn();
}

registerOutputEvent("Minigame","crFreeAllPlayers","",1);
function MinigameSO::crFreeAllPlayers(%this,%client)
{
   if(%this.roundWon || %this.gamemode != gameModeTitleToID("Cops and Robbers"))
      return;
   
   %found = -1;
   %time = $Sim::Time;
   for(%i=0;%i<%this.numMembers;%i++)
   {
      %cl = %this.member[%i];
      if(%cl.tdmTeam == 1 && %cl.isCRJailed)
      {
         %found = 1;
         %cl.isCRJailed = 0;
         %cl.CRJailTime = "";
         %cl.instantRespawn();
      }
   }
   
   if(!%found)
      return;
   
   %this.crCopDeaths = 0;
   %this.messageAll('',clientTeamName(%client) @ " \c5freed everyone from jail!");
}

datablock fxDTSBrickData(brickCRBankData : brick2x2data)
{
	uiName = "Bank Brick";
	category = "SpaceMods";
	subCategory = "Team DM: C&R";
	
	autoApplyEvent_Input[0] = "onPlayerTouch";
	autoApplyEvent_Target[0] = "Player";
	autoApplyEvent_Output[0] = "crStealMoney";
	autoApplyEvent_Param[0,0] = 0; //default amount = minigame settings, change it for different money amounts stolen
};

datablock fxDTSBrickData(brickCRRobBaseData : brick2x2data)
{
	uiName = "Robber Base";
	Category = "SpaceMods";
	subCategory = "Team DM: C&R";
	
	autoApplyEvent_Input[0] = "onPlayerTouch";
	autoApplyEvent_Target[0] = "Player";
	autoApplyEvent_Output[0] = "crReturnMoney";
};

datablock fxDTSBrickData(brickCRJailSpawnData : brickSpawnPointData)
{
	category = "SpaceMods";
	subCategory = "Team DM: C&R";
	uiName = "Jail Spawn";
	specialBrickType = "";
	
	isTDMBrick = 1; //Only this one needs to be checked during the game mode, so this is the only one I add to the set
};

datablock ItemData(crPoliceBatItem : hammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	colorShiftColor = "0.0 0.0 0.5 1.000";
	uiname = "Police Baton";
	image = crPoliceBatImage;
	canDrop = true;
};

datablock ShapeBaseImageData(crPoliceBatImage : hammerImage)
{
	item = crPoliceBatItemItem;
	ammo = " ";
	colorShiftColor = "0.0 0.0 0.5 1.000";
	
	raycastWeaponRange = 2;
	raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
						$TypeMasks::PlayerObjectType |	//AI/Players
						$TypeMasks::StaticObjectType |	//Static Shapes
						$TypeMasks::TerrainObjectType |	//Terrain
						$TypeMasks::VehicleObjectType;	//Vehicles
	raycastExplosionProjectile = hammerProjectile;
	raycastExplosionSound = hammerHitSound;
	raycastDirectDamage = 10;
	raycastDirectDamageType = $DamageType::HammerDirect;

	showBricks = 0;
};

function crPoliceBatImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function crPoliceBatImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function crPoliceBatImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal)
{ 
 %mini = %obj.client.minigame;
 
 if(!(%col.getType() & $TypeMasks::PlayerObjectType))
  return Parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal);
 
 if(!isObject(%mini) || !miniGameCanDamage(%obj,%col) || %mini.roundWon || %mini.gameMode != gameModeTitleToID("Cops and Robbers") || %obj.client.tdmTeam != 0 || %col.client.tdmTeam != 1)
  return Parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal);
 
 if(%col.getState() $= "Dead" || %col.getDamagePercent()*100 < 100-%mini.tdmModeRule[3])
  return Parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal);
 
 if(!%col.client.isCRJailed)
 {
  %col.client.isCRJailed = 1;
  %col.client.CRJailTime = $Sim::Time;
  
  %mini.messageAll('',clientTeamName(%obj.client) @ "\c5 captured " @ clientTeamName(%col.client) @ "\c5!");
  %mini.crCopDeaths = 0;
  
  %win = 1;
  for(%i=0;%i<%mini.numMembers;%i++)
  {
   %cl = %mini.member[%i];
   if(%cl.tdmTeam == 1 && !%cl.isCRJailed)
   {
    %win = 0;
    break;
   }
  }
  
  %col.client.instantRespawn();
  
  if(%win)
   %mini.roundEnd(0,1);
  else if(isObject(%col.client))
   %col.client.bottomPrint("\c3Jump\c6 to toggle \c3Spectator Mode\c7.",10);

  %ret = Parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal);
 }
 else
 {
  %ret = Parent::onHitObject(%this,%obj,%slot,%col,%pos,%normal);
 }
 return %ret;
}

datablock ItemData(crMoneyItem : hammerItem)
{
	shapeFile = "base/data/shapes/brickweapon.dts";
	
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	colorShiftColor = "0.0 0.4 0.0 1.000";
	uiname = "C&R Money";
	image = hammerImage;
	canDrop = true;
};

function crMoneyItem::onPickup(%this,%obj,%player,%amt)
{
	if(isObject(%obj.spawnBrick))
	{
		%mini = %obj.spawnBrick.getGroup().client.minigame;
		%team = %player.client.tdmTeam;
		
		if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Cops and Robbers"))
			return;
		
		if(%team != 1 || %player.crMoney > 0 || %player.client.isCRJailed)
			return;	
		
		if(%obj.canPickup == 1 && miniGameCanUse(%player,%obj))
		{
			%player.crStealMoney(0,%player.client);
			serverPlay3d(errorSound,%obj.getPosition());
			%obj.canPickup = 0;
			%obj.fadeOut();
			%obj.schedule(500,fadeIn);
		}
		return 1;
	}
	
	if(!isObject(%player.client))
		return;
	
	if(%player.client.minigame != %obj.spawnminigame)
	{
		if(isObject(%player.client.minigame))
			%player.client.centerPrint("This item is in a different mini-game.",2);
		else
			%player.client.centerPrint("This item is part of a mini-game.",2);
		return;
	}
	
	%mini = %player.client.minigame;
	%team = %player.client.tdmTeam;
	
	if(%mini.roundWon || %mini.gamemode != gameModeTitleToID("Cops and Robbers"))
		return 0;
	
	if(%team == 0)
	{
		%player.client.play2d(rewardSound);
		%player.emote(winStarProjectile,1);
		%obj.deletePoof();
		return 0;
	}
	
	if(%team != 1 || %player.crMoney > 0 || %player.client.isCRJailed)
		return;	

	%player.client.play2d(rewardSound);
	%player.emote(winStarProjectile,1);
	%player.crMoney = %obj.moneyamt;
	
	%obj.delete();
	return 1;
}

function Item::deletePoof(%obj)
{
	%p = new Projectile()
	{
		dataBlock = deathProjectile;
		initialPosition = %obj.getPosition();
		initialVelocity = "0 0 1";
		sourceObject = %obj;
		sourceSlot = 0;
	};
	%p.setScale("0.5 0.5 0.5");
	%p.explode();
	
	%obj.delete();
}